//EHArray.c
#include "EHArray.h"
#include <stdlib.h>
void EHArray_EHArray(EHArray *eharr, int icapa, Element ivalue);
EHArray *New_EHArray(int icapa, Element ivalue)
{
    EHArray *eharr = 0;
    eharr = (EHArray *)malloc(sizeof(EHArray));
    EHArray_EHArray(eharr, icapa, ivalue);
    return eharr;
}
void EHArray_Reserve(EHArray *eharr, int icapa);
void EHArray_PushBacks(EHArray *eharr, int icapa, Element ivalue);
void EHArray_EHArray(EHArray *eharr, int icapa, Element ivalue)
{
    eharr->base = 0;
    eharr->capacity = 0;
    eharr->size = 0;
    if (icapa > 0)
    {
        EHArray_Reserve(eharr, icapa);
        EHArray_PushBacks(eharr, icapa, ivalue);
    }
}
void EHArray_Reserve(EHArray *eharr, int icapa)
{
    eharr->base = (Element *)realloc(eharr->base, sizeof(Element)*icapa);
    eharr->capacity = icapa;
}
void EHArray_PushBacks(EHArray *eharr, int icapa, Element ivalue)
{
    int i = 0;
    for (i = 0; i < icapa; i++)
    {
        EHArray_PushBack(eharr, ivalue);
    }
}
void EHArray_TEHArray(EHArray *eharr);
void Delete_EHArray(EHArray *eharr)
{
    EHArray_TEHArray(eharr);
    free(eharr);
}
void EHArray_TEHArray(EHArray *eharr)
{
    free(eharr->base);
}
int EHArray_GetCapacity(EHArray *eharr)
{
    return eharr->capacity;
}
int EHArray_GetSize(EHArray *eharr)
{
    return eharr->size;
}
void EHArray_PushBack(EHArray *eharr, Element data)
{
    if (eharr->capacity == eharr->size)
    {
        if (eharr->capacity)
        {
            EHArray_Reserve(eharr, eharr->capacity * 2);
        }
        else
        {
            EHArray_Reserve(eharr, 1);
        }
    }
    eharr->base[eharr->size] = data;
    eharr->size++;
}
Element EHArray_GetAt(EHArray *eharr, int index)
{
    if ((index >= 0) && (index < eharr->size))
    {
        return eharr->base[index];
    }
    return 0;
}
void EHArry_SetAt(EHArray *eharr, int index, Element data)
{
    if ((index >= 0) && (index < eharr->size))
    {
        eharr->base[index] = data;
    }
}
Iterator EHArray_Begin(EHArray *eharr)
{
    return eharr->base;
}
Iterator EHArray_End(EHArray *eharr)
{
    return eharr->base + eharr->size;
}
void EHArray_Erase(EHArray *eharr, Iterator it)
{
    Iterator end;
    eharr->size--;
    end = eharr->base + eharr->size;
    for (; it != end; it++)
    {
        *it = *(it + 1);
    }
}